import {
    Metadata, Http,
} from '@zeedhi/core';
import {
   Modal, ModalService, Form, Select, TextInput, LoadingService, DateRange, SelectMultiple,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';
import { ZdSelect } from '@zeedhi/vuetify';

export class ControllerParametrizacaoGeral {
    private mnemonicosModal!: Modal;

    public text: any;

    public tipoCarregamento: any;

    public modificarUtilizacaoMascara() {
        //     const utilizarMascara = (component.value === 'N');
        //     const mascara = Metadata.getInstance<TextInput>('InputMascara');
        //     mascara.disabled = utilizarMascara;
        //     Metadata.getInstance<Button>('BtnMnemonicos').disabled = utilizarMascara;
        //     Metadata.getInstance<Select>('SelectPermissao').disabled = utilizarMascara;
        //     if (utilizarMascara) {
        //         mascara.removeValidation('required');
        //     } else {
        //         mascara.addValidation('required');
        //     }
    }

    public validaAlerta({ component }: any) {
        const conform = Metadata.getInstance<Select>('selectConformidades');
        const emails = Metadata.getInstance<Select>('selectEmails');

        if (component.value === 'S') {
                conform.addValidation('required');
                emails.addValidation('required');
                conform.disabled = false;
                emails.disabled = false;
            } else {
                conform.removeValidation('required');
                emails.removeValidation('required');
                conform.disabled = true;
                emails.disabled = true;
                conform.value = '';
                emails.value = '';
            }
    }

    public salvarParametrizacoes() {
        const form = Metadata.getInstance<Form>('formParametrizacao_dropBoxTarefas');
        const formLocais = Metadata.getInstance<Form>('formParametrizacao_dropBoxLocaisAtendimento');
        const alertaNaoConformidades = Metadata.getInstance<Form>('formParametrizacao_dropBoxNotificacoesNaoConformidades');
        const formAppOffline = Metadata.getInstance<Form>('formParametrizacao_dropBoxAppOffline');
        if (form.validate() && formLocais.validate() && formAppOffline.validate() && alertaNaoConformidades.validate()) {
            const paramConflito = Metadata.getInstance<ZdSelect>('selectValidacaoConflito').value;
            const permiteGeolocalizacao = Metadata.getInstance<ZdSelect>('geolocalizacaoAtendimento').value;
            const iniciarTarGeolocalizacao = Metadata.getInstance<ZdSelect>('geolocalizacaoIniciarTarefa').value;
            const xDias = Metadata.getInstance<TextInput>('qtdDiasParam').value;
            const personalizado = Metadata.getInstance<DateRange>('dataParam').value;
            const modoOffline = Metadata.getInstance<Select>('selectSimpleResult').value;
            const enviarAlerta = Metadata.getInstance<Select>('selectEnviarAlerta').value;
            const naoConformidades = Metadata.getInstance<SelectMultiple>('selectConformidades').value;
            const emailsAlerta = Metadata.getInstance<TextInput>('selectEmails').value;
            const habilidadesOper = Metadata.getInstance<ZdSelect>('habilidadesOperador').value;
            LoadingService.show();
            Http.post('/salvarParametrizacoes', {
                CONFLITO: paramConflito,
                PERGEOLOCALIZACAO: permiteGeolocalizacao,
                INICIARTARGEOLOCALIZACAO: iniciarTarGeolocalizacao,
                XDIAS: xDias,
                DATARANGE: personalizado,
                TIPOCARREGAMENTO: this.tipoCarregamento,
                USAOFFLINE: modoOffline,
                IDNOTIFNAOCONFORM: enviarAlerta,
                LISTNOTIFNAOCONFORM: naoConformidades,
                EMAILSNOTIFNAOCONFROM: emailsAlerta,
                HABILIDADEOPERADOR: habilidadesOper,
            }).then(() => {
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    public async getParametrizacoes() {
        let retorno: any = [];
        let dtInicialFinal: any;
        await Http.get('/getParametrizacoes').then((response) => {
            retorno = response;
            if (response.data.length > 0) {
                dtInicialFinal = [response.data[0].DTINICAL];
                dtInicialFinal.push([response.data[0].DTFINAL]);
                Metadata.getInstance<Select>('geolocalizacaoAtendimento').value = response.data[0].IDUTILIZAGEOLOCAL;
                Metadata.getInstance<Select>('geolocalizacaoIniciarTarefa').value = response.data[0].IDUTILIZAGEOLOCALINITAR;
                Metadata.getInstance<ZdSelect>('selectValidacaoConflito').value = response.data[0].IDVALIDACRIATAREFA;
                Metadata.getInstance<TextInput>('qtdDiasParam').value = response.data[0].QTDIASCARREGAOFFLINE;
                Metadata.getInstance<Select>('selectSimpleResult').value = response.data[0].IDHABILITAOFFLINE;
                Metadata.getInstance<Select>('defineEscolhaData').value = response.data[0].IDTIPOCARREGAOFFLINE;
                Metadata.getInstance<DateRange>('dataParam').value = dtInicialFinal;
                this.changeGeolocalizacaoLocalAtendimento(retorno.data[0]);
                Metadata.getInstance<Select>('selectEnviarAlerta').value = response.data[0].IDNOTIFNAOCONFORM;
                Metadata.getInstance<SelectMultiple>('selectConformidades').value = (response.data[0].LISTNOTIFNAOCONFORM !== null) ? response.data[0].LISTNOTIFNAOCONFORM.split('_').map(Number) : '';
                Metadata.getInstance<TextInput>('selectEmails').value = response.data[0].EMAILSNOTIFNAOCONFROM;
                Metadata.getInstance<Select>('habilidadesOperador').value = response.data[0].IDUTILIZAHABILIDADE;
            }
        });
    }

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(`formParametrizacao_${component.name}`);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public changeGeolocalizacaoLocalAtendimento(permiteGeo: any) {
        const inicioTarefaGeo = Metadata.getInstance<Select>('geolocalizacaoIniciarTarefa');
        const exibeGeolocalizacao = Metadata.getInstance<Select>('geolocalizacaoAtendimento');
        if (permiteGeo.IDUTILIZAGEOLOCAL === 'N' || exibeGeolocalizacao.value === 'N') {
            inicioTarefaGeo.value = 'N';
            inicioTarefaGeo.disabled = true;
        } else if (exibeGeolocalizacao.value === 'S') {
            inicioTarefaGeo.disabled = false;
        }
    }

    public async openMnemonicosModal() {
        this.mnemonicosModal = await ModalService.create({
            name: 'mnemonicosModal',
            children: [
                {
                    name: 'mnemonicostHeader',
                    component: 'ZdHeader',
                    color: 'transparent',
                    padless: true,
                    elevation: 0,
                    leftSlot: [
                        {
                            name: 'titleText',
                            component: 'ZdText',
                            text: 'Mnemônicos',
                        },
                    ],
                    rightSlot: [
                        {
                            name: 'closeModal',
                            component: 'ZdButton',
                            iconName: 'mdi-close',
                            icon: true,
                            events: {
                                click: '{{ControllerParametrizacaoGeral.closeMnemonicosModal}}',
                            },
                        },
                    ],
                },
                {
                    name: 'form',
                    component: 'ZdForm',
                    children: [
                        {
                            name: 'MnemonicoSeq',
                            component: 'ZdText',
                            text: '[SEQ]',
                            grid: {
                                cols: 3,
                            },
                        },
                        {
                            name: 'DescricaoSeq',
                            component: 'ZdText',
                            text: '– Número sequencial para geração da máscara.',
                            grid: {
                                cols: 9,
                            },
                        },
                        {
                            name: 'MnemonicoSetor',
                            component: 'ZdText',
                            text: '[SETOR]',
                            grid: {
                                cols: 3,
                            },
                        },
                        {
                            name: 'DescricaoSetor',
                            component: 'ZdText',
                            text: '– Nome do setor.',
                            grid: {
                                cols: 9,
                            },
                        },
                        {
                            name: 'MnemonicoLocalAtendimento',
                            component: 'ZdText',
                            text: '[NMABLOC]',
                            grid: {
                                cols: 3,
                            },
                        },
                        {
                            name: 'DescricaoLocalAtendimento',
                            component: 'ZdText',
                            text: '– Nome abreviado do local de atendimento.',
                            grid: {
                                cols: 9,
                            },
                        },
                        {
                            name: 'MnemonicoLocalSuperior',
                            component: 'ZdText',
                            text: '[NMABLOCS]',
                            grid: {
                                cols: 3,
                            },
                        },
                        {
                            name: 'DescricaoLocalSuperior',
                            component: 'ZdText',
                            text: '– Nome abreviado do local de atendimento superior.',
                            grid: {
                                cols: 9,
                            },
                        },
                        {
                            name: 'MnemonicoTodosLocais',
                            component: 'ZdText',
                            text: '[NMABLOCSALL{}]',
                            grid: {
                                cols: 3,
                            },
                        },
                        {
                            name: 'DescricaoTodosLocais',
                            component: 'ZdText',
                            text: '– Nome abreviado de todos os locais de atendimento superiores, no caso o delimitador que separa os locais, deve ser colocado dento das chaves.',
                            grid: {
                                cols: 9,
                            },
                        },
                    ],
                },
            ],
        });
        this.mnemonicosModal.show();
    }

    public closeMnemonicosModal() {
        this.mnemonicosModal.hide();
        this.mnemonicosModal?.destroy();
    }

    public changeTipoCarregamento({ component }: any) {
        const xDias = Metadata.getInstance<TextInput>('qtdDiasParam');
        const personalizado = Metadata.getInstance<DateRange>('dataParam');
        if (component.value === '1') {
            xDias.isVisible = true;
            personalizado.isVisible = false;
            personalizado.value = null;
        } else {
            personalizado.isVisible = true;
            xDias.isVisible = false;
            xDias.value = null;
        }
        this.tipoCarregamento = component.value;
    }

    public modoOffline({ component }: any) {
        const labelDefineData = Metadata.getInstance<Select>('defineEscolhaData');
        const personalizado = Metadata.getInstance<DateRange>('dataParam');
        const xDias = Metadata.getInstance<TextInput>('qtdDiasParam');
        if (component.value === 'N') {
            labelDefineData.value = '';
            labelDefineData.disabled = true;
            personalizado.isVisible = false;
            xDias.isVisible = false;
        } else {
            labelDefineData.disabled = false;
        }
    }
}
